interface Female {
    highly_skilled: boolean
}

class Business_woman implements Female {
    highly_skilled = true; /* Implementation */
}

class /* 'interface' also works... */
    Manager { /* Empty for test */
}

type FemaleAndManager = Female & Manager;
const fm: FemaleAndManager = new Business_woman;
window.console.assert(fm.highly_skilled);

interface Animal {
    children: Array<Animal>;
}

class Mammal implements Animal {
    children: Array<Animal> = new Array(); /* Implementation */
}

class Oviparous implements Animal {
    children: Array<Animal> = new Array(); /* Implementation */
    // eggs: any; // Compilation error!
}

const o: Mammal & Oviparous = new Mammal; // Property 'eggs' is missing in type 'Mammal' but required in type 'Oviparous'.


interface Flying_fox {
    fly: () => void;
}

interface Fox {
    run: () => void;
}

const Hunt = function (f: Flying_fox | Fox): void {
    if ('fly' in f) {
        f.fly();
    }
};
